//@+ CheckArithOverflow = no

/*@ lemma distributivity:
    \forall integer q, integer b;
    (q + 1) * b == q * b + b; */

class Division {

  /*@ requires a >= 0 && b > 0 ;
      ensures  \exists integer r;
               \result * b + r == a && 0 <= r < b ; */
  static int division (int a, int b)
  {
    int q = 0;
    int r = a;
    /*@ loop_invariant q * b + r == a && 0 <= r ;
        loop_variant r ; */
    while (r >= b) {
      q++;
      r -= b;
    }
    return q;
  }

}
